#ifndef f_VDUNKNOWN_H
#define f_VDUNKNOWN_H

extern "C" long _InterlockedExchangeAdd(volatile long *p, long v);
#pragma intrinsic(_InterlockedExchangeAdd)

namespace {
	template<class T> class vdxunknown : public T {
	public:
		vdxunknown() : mRefCount(0) {}
		vdxunknown(const vdxunknown<T>& src) : mRefCount(0) {}		// do not copy the refcount
		virtual ~vdxunknown() {}

		vdxunknown<T>& operator=(const vdxunknown<T>&) {}			// do not copy the refcount

		virtual int VDXAPIENTRY AddRef() {
			return _InterlockedExchangeAdd(&mRefCount, 1) + 1;
		}

		virtual int VDXAPIENTRY Release() {
			long rc = _InterlockedExchangeAdd(&mRefCount, -1) - 1;
			if (!mRefCount) {
				mRefCount = 1;
				delete this;
				return 0;
			}

			return rc;
		}

		virtual void *VDXAPIENTRY AsInterface(uint32 iid) {
			if (iid == T::kIID)
				return static_cast<T *>(this);

			if (iid == IVDXUnknown::kIID)
				return static_cast<IVDXUnknown *>(this);

			return NULL;
		}

	protected:
		volatile long	mRefCount;
	};
}

#endif	// f_VDUNKNOWN_H