#ifndef f_VIDEOCODEC_H
#define f_VIDEOCODEC_H

class VideoCodec {

private:
	typedef struct OUTPUTFORMAT {
		BITMAPINFOHEADER	bmih;
		DWORD				bmiColors[3];
	};

	BITMAPINFOHEADER *bmihIn;
	OUTPUTFORMAT bmihOut;

	bool SetInputFormat(const BITMAPINFOHEADER *in);
	bool QueryOutputFormat(int format);
	bool LockFormat(int format, const OUTPUTFORMAT *bmih);
	bool QueryDecompressor(BITMAPINFOHEADER *out);

public:
	VideoCodec();
	~VideoCodec();

// We are trusting our host NOT to modify these!
	HIC hCodec;
	VDXPixmap mPixmap;
	unsigned char *mFrameBuffer;

	bool Init(const BITMAPINFOHEADER *in, int format);
	bool Decompress(LPVOID inputBuffer, DWORD len, DWORD flags);
	void Inform(LPCSTR szText);
};

#endif	// f_VIDEOCODEC_H